/*
 * $Id: screenprefs.c,v 1.9 2009/01/13 13:11:27 jacadcaps Exp $
 */
#define AROS_ALMOST_COMPATIBLE
#include "global.h"
#include <libraries/mui.h>
#include <exec/ports.h>
#include <libraries/iffparse.h>
#include <intuition/intuitionbase.h>

#include <string.h>

#include <aros/libcall.h>
#include <aros/asmcall.h>
#define DEBUG 0
#include <aros/debug.h>

#define COMPARE_WITH_OLD_PREFS

#if 0
static struct ScreenModePrefs ScreenPrefs;
static APTR OldOpenScreenTagList;

/*********************************************************************************************/

AROS_UFH3(struct Screen *, MyOpenScreenTagList,
		  AROS_UFHA(struct NewScreen *, ns, A0),
		  AROS_UFHA(struct TagItem *, tags, A1),
		  AROS_UFHA(struct IntuitionBase *, IntuitionBase, A6))
{
	AROS_LIBFUNC_INIT

	struct TagItem *newtags = NULL;
	struct Screen *screen;
	static const Tag filtertags[] =
	    {
	        SA_Width, SA_Height, SA_Depth, SA_DisplayID, SA_AutoScroll, TAG_END
	    };
	struct TagItem mytags[6];

	if (tags && GetTagData(SA_Type, 0, tags) == WBENCHSCREEN)
	{
		if (newtags = CloneTagItems(tags))
		{
			FilterTagItems(newtags, filtertags, TAGFILTER_NOT);
			mytags[0].ti_Tag  = SA_Width;
			mytags[0].ti_Data = ScreenPrefs.smp_Width;
			mytags[1].ti_Tag  = SA_Height;
			mytags[1].ti_Data = ScreenPrefs.smp_Height;
			mytags[2].ti_Tag  = SA_Depth;
			mytags[2].ti_Data = ScreenPrefs.smp_Depth;
			mytags[3].ti_Tag  = SA_DisplayID;
			mytags[3].ti_Data = ScreenPrefs.smp_DisplayID;
			mytags[4].ti_Tag  = SA_AutoScroll;
			mytags[4].ti_Data = ScreenPrefs.smp_Control & SMF_AUTOSCROLL;
			mytags[5].ti_Tag  = TAG_MORE;
			mytags[5].ti_Data = (ULONG)newtags;
			tags = mytags;
		}
	}

	screen = (struct Screen *)AROS_UFC3(struct Screen *, OldOpenScreenTagList,
	                                    AROS_UFCA(struct NewScreen *, ns, A0),
	                                    AROS_UFCA(struct TagItem *, tags, A1),
	                                    AROS_UFCA(struct IntuitionBase *, IntuitionBase, A6));

	FreeTagItems(newtags);

	return screen;

	AROS_LIBFUNC_EXIT
}

/*********************************************************************************************/

void InstallScreenPatch(void)
{
	OldOpenScreenTagList = SetFunction(IntuitionBase, -6 * 102, AROS_ASMSYMNAME(MyOpenScreenTagList));
}

void RemoveScreenPatch(void)
{
	SetFunction(IntuitionBase, -6 * 102, OldOpenScreenTagList);
}
#endif

/*********************************************************************************************/

#if 0 /* for jaca */

#endif

/*********************************************************************************************/

#define IPC_WINCOUNT 6

struct ipcmessage {
	struct Message msg;
	APTR pool;
	ULONG type;
	APTR msgtype;
};

struct ipc_wincount {
	ULONG wincount;
	ULONG wbr;
};

struct Screen *FindWBScreen(void)
{
	struct List *PubScreenList;
	struct PubScreenNode *MyPubNode;
	struct Screen *MyScreen = NULL;

	D(bug("Searching for WB screen\n"));

	D(bug("IPrefs: search Workbench screen\n"));
	PubScreenList = LockPubScreenList();
	MyPubNode	=(struct PubScreenNode*) PubScreenList->lh_Head;
	while (MyPubNode->psn_Node.ln_Succ)
	{
		D(bug("IPrefs: pubnode 0x%lx <%s> Screen 0x%lx Flags 0x%lx Size %ld VisitorCount %ld SigTask 0x%lx SigBit %ld\n",
		      (ULONG)MyPubNode,
		      MyPubNode->psn_Node.ln_Name,
		      (ULONG)MyPubNode->psn_Screen,
		      (ULONG)MyPubNode->psn_Flags,
		      (LONG) MyPubNode->psn_Size,
		      (LONG) MyPubNode->psn_VisitorCount,
		      (ULONG)MyPubNode->psn_SigTask,
		      (LONG) MyPubNode->psn_SigBit));

		if ((MyPubNode->psn_Node.ln_Name != NULL) &&
		        (strcmp(MyPubNode->psn_Node.ln_Name,
		                "Workbench") == 0))
		{
			D(bug("IPrefs: found wb screen\n"));
			MyScreen = MyPubNode->psn_Screen;
			break;
		}
		MyPubNode	=(struct PubScreenNode*) MyPubNode->psn_Node.ln_Succ;
	}
	UnlockPubScreenList();

	return MyScreen;
}

/*********************************************************************************************/

static int WindowsLeftOnWB(void)
{
	struct Screen *wb = NULL;
	struct Screen *wbopen;
	struct Window *window;
	struct MsgPort *mp;
	ULONG numwindows = 0;
	ULONG subcount = 0;

	/* Lock Workbench pubscreen, not the default one! - Piru */
	/* But LockPubScreen("Workbench") causes it to be opened, let's do it nicely - jDc */
	//wb = LockPubScreen(NULL);
	//wb = LockPubScreen("Workbench");

	wbopen = FindWBScreen();

	if (wbopen) wb = LockPubScreen("Workbench");

	if (!wb)
	{
		D(bug("IPrefs: Unable to lock Workbench pubscreen\n"));
		return 0;
	}

	/*
	 * Ambient does't set the WFLG_WBENCHWINDOW for
	 * its windows as intuition has a workaround for the
	 * original WB. So we need to query Ambient to substract
	 * its number of windows from the total number of windows
	 * on screen.
	 */
	Forbid();
	if ((mp = FindPort("Ambient IPC")))
	{
		struct ipcmessage gmsg;
		struct ipc_wincount msg;
		struct MsgPort rport;

		rport.mp_Node.ln_Type = NT_MSGPORT;
		//rport.mp_Node.ln_Pri  = 0;
		//rport.mp_Node.ln_Name = NULL;
		rport.mp_Flags = PA_SIGNAL;
		rport.mp_SigBit = SIGB_SINGLE;
		rport.mp_SigTask = FindTask(NULL);
		NEWLIST(&rport.mp_MsgList);

		gmsg.pool = NULL;
		gmsg.msg.mn_ReplyPort = &rport;
		gmsg.type = IPC_WINCOUNT;
		gmsg.msgtype = &msg;

		msg.wincount = 0;
		msg.wbr = FALSE;

		SetSignal(0, SIGF_SINGLE);
		PutMsg(mp, (struct Message *)&gmsg);

		Permit();

		WaitPort(&rport);
		while (GetMsg(&rport));

		if (msg.wbr)
		{
			subcount = msg.wincount;
		}
	}
	else
	{
		Permit();
	}

	window = wb->FirstWindow;

	D(bug("IPrefs: firstwindow 0x%lx\n",
	      (ULONG) window));

	while (window)
	{
		if (!(window->Flags & WFLG_WBENCHWINDOW))
		{
			numwindows++;
		}

		window = window->NextWindow;
	}

	UnlockPubScreen(NULL, wb);

	D(bug("%ld window%s left on WB (subcount: %ld)\n", numwindows, numwindows==1?"":"s", subcount));

	return (numwindows - subcount);
}

/*********************************************************************************************/

static BOOL NewScreenData(struct Screen *screen,
						  struct ScreenModePrefs *prefs,struct ScreenModePrefs *oldprefs)
{

#ifdef COMPARE_WITH_OLD_PREFS
	if (((struct Library *)IntuitionBase)->lib_Version >= 51)
	{
		if (prefs->smp_DisplayID != oldprefs->smp_DisplayID) return TRUE;
		if (prefs->smp_Depth != oldprefs->smp_Depth) return TRUE;
		if (prefs->smp_Width != oldprefs->smp_Width) return TRUE;
		if (prefs->smp_Height != oldprefs->smp_Height) return TRUE;
		if (prefs->smp_Control != oldprefs->smp_Control) return TRUE;
		if (prefs->smp_Depth != oldprefs->smp_Depth) return TRUE;
		return FALSE;
	}
	else
#endif
	{
	ULONG	ModeID;

	#warning "Ignores Autoscroll..we need some GetIPrefs to make this safe"
		D(bug("IPrefs: new DisplayID 0x%lx Width %ld Height %ld Depth %ld Control 0x%lx\n",
			prefs->smp_DisplayID,
			(LONG) prefs->smp_Width,
			(LONG) prefs->smp_Height,
			(LONG) prefs->smp_Depth,
			(ULONG) prefs->smp_Control));

		ModeID = screen->ViewPort.ColorMap->VPModeID;
		D(bug("IPrefs: screen DisplayID 0x%lx Width %ld Height %ld DWidth %ld DHeight %ld\n",
			ModeID,
			(LONG) screen->Width,
			(LONG) screen->Height,
			(LONG) screen->ViewPort.DWidth,
			(LONG) screen->ViewPort.DHeight));


		if (ModeID == prefs->smp_DisplayID)
		{
			#if 0
			DisplayInfoHandle displayinfo;
			struct DimensionInfo dimensions;
			#endif

			UWORD swidth;
			UWORD sheight;

			swidth = prefs->smp_Width;
			sheight = prefs->smp_Height;

			#if 1
			/* jDc: wtf are those finddisplayinfo/getdisplayinfodata checks?? it's
			completly useless since the screen cannot be opened with a invalid mode in it's viewport */
			if (prefs->smp_Width == (UWORD) STDSCREENWIDTH)
			{
				swidth = screen->ViewPort.DWidth;
			}
			if (prefs->smp_Height == (UWORD) STDSCREENHEIGHT)
			{
				sheight = screen->ViewPort.DHeight;
			}
			#else
			if ((displayinfo = FindDisplayInfo(ModeID)))
			{
				if (GetDisplayInfoData(displayinfo, &dimensions, sizeof(dimensions), DTAG_DIMS, ModeID))
				{
					if (prefs->smp_Width == (UWORD) STDSCREENWIDTH)
					{
						swidth = screen->ViewPort.DWidth;
					}
					if (prefs->smp_Height == (UWORD) STDSCREENHEIGHT)
					{
						sheight = screen->ViewPort.DHeight;
					}
				}
			}
			else
			{
				D(bug("IPrefs: can't get displayinfo\n"));
			}
			#endif


			D(bug("IPrefs: swidth %ld sheight %ld\n",
				(LONG) swidth,
				(LONG) sheight));

			if ((swidth==screen->Width) &&
			    (sheight==screen->Height))
			{
				D(bug("IPrefs: assume screenmode is the same\n"));
				return FALSE;
			}
		}
		else
		{
			D(bug("IPrefs: screenmode different\n"));
			if ((prefs->smp_DisplayID == INVALID_ID) ||
			    !FindDisplayInfo(prefs->smp_DisplayID))
			{
				/* prefs contain a bogus value, reopening is useless */
				return FALSE;
			}
		}
	}

	return TRUE;
}

/*********************************************************************************************/

#if USE_DELAYEDREOPENWB

extern struct timerequest	*ReOpenWBtimereq;
extern BOOL			ReOpenWBtimer;
static BOOL			Firstopen = TRUE;

void DoReOpenWBScreen(void);

void ReOpenWBScreen(struct Screen *MyScreen)
{
	if (Firstopen)
	{
		Firstopen = FALSE;
		DoReOpenWBScreen();
		return;
	}

	if (!ReOpenWBtimer)
	{
		ReOpenWBtimereq->tr_node.io_Command = TR_ADDREQUEST;
		ReOpenWBtimereq->tr_node.io_Flags   = 0;
		/* Delay the reopen for 0.5 seconds - Piru */
		ReOpenWBtimereq->tr_time.tv_secs    = 0;
		ReOpenWBtimereq->tr_time.tv_micro   = 500000;
		SendIO((struct IORequest *) ReOpenWBtimereq);

		ReOpenWBtimer = TRUE;
	}
}

void DoReOpenWBScreen(void)
{
	LONG srhret;
	int closewbret = 0;

	D(bug("IPrefs: CloseWorkbench\n"));
	srhret = -1;

	if (!FindWBScreen()) return;
	
	if ((!(closewbret = CloseWorkBench())))
	{
		struct Window fakewindow;
		struct Window *reqwin;
		struct EasyStruct es;
		int autotries;

		D(bug("IPrefs: closewbret %ld\n",
			(LONG) closewbret));
		D(bug("IPrefs: enter CloseWorkbench loop\n"));

		fakewindow.Title = "IPrefs Requester";
		es.es_StructSize   = sizeof(es);
		es.es_Flags        = 0;
		es.es_Title        = "IPrefs Requester";
		es.es_GadgetFormat = "Ok|Cancel";
		es.es_TextFormat   = "IPrefs is trying to reopen the Ambient screen.\n"
		                     "Please close all non-Ambient windows.";

		do
		{
			ULONG winnum;

			winnum = WindowsLeftOnWB();
			D(bug("IPrefs: winnum %ld\n",
			      winnum));

			autotries = 0;

			if (winnum != 0 && (fakewindow.WScreen = FindWBScreen()))
			{
#warning "Could use LOGO_ATTENTION or LOGO_INFORMATION or so. - Piru"
				reqwin = BuildEasyRequest(&fakewindow, &es, 0, 0);
				D(bug("IPrefs: reqwin 0x%lx\n",
					(ULONG) reqwin));

				while (! (((srhret = SysReqHandler(reqwin, 0, FALSE)) >= 0) ||
				       ((winnum=WindowsLeftOnWB()) == 1 || autotries >= 5)) )
				{
					D(bug("IPrefs: sleep, retry %ld current winnum %ld\n",
					      (LONG) autotries,
					      (LONG) winnum));
					Delay(5);
					D(bug("IPrefs: wake up\n"));
				}
				FreeSysRequest(reqwin);
				D(bug("IPrefs: srhret %ld\n",
				      srhret));

				if (srhret == 0)
				{
					D(bug("IPrefs: cancel..leave retry\n"));
					break;
				}
				else
				{
					autotries++;
					D(bug("IPrefs: autotries %ld\n",
						(LONG) autotries));
				}
			}
			else if (winnum == 0)
			{
				if (!FindWBScreen()) break;
			}
		} while (!(closewbret = CloseWorkBench()));
	}

	D(bug("IPrefs: closewbret %ld\n",
		(LONG) closewbret));

	if (srhret != 0)
	{
		D(bug("IPrefs: reopen Workbench\n"));
		OpenWorkBench();
	}
}

#else /* USE_DELAYEDREOPENWB */

void ReOpenWBScreen(struct Screen *MyScreen)
{
	LONG srhret;
	int closewbret;

	if (!FindWBScreen()) return;
	
	D(bug("IPrefs: CloseWorkbench\n"));
	srhret = -1;
	if (!(closewbret = CloseWorkBench()))
	{
		struct Window window;
		struct Window *reqwin;
		struct EasyStruct es;
		int autotries;

		D(bug("IPrefs: closewbret %ld\n",
			(LONG) closewbret));
		D(bug("IPrefs: enter CloseWorkbench loop\n"));

		window.Title = "IPrefs Requester";
		window.WScreen = MyScreen;
		es.es_StructSize = sizeof(es);
		es.es_Flags = 0;
		es.es_Title = "IPrefs Requester";
		es.es_GadgetFormat = "Ok|Cancel";
		es.es_TextFormat = "IPrefs is trying to reopen the Ambient screen.\n"
		                   "Please close all non-Ambient windows.";

		do
		{
			ULONG winnum;

			winnum = WindowsLeftOnWB();
			D(bug("IPrefs: winnum %ld\n",
			      winnum));

			autotries = 0;

			if (winnum != 0)
			{
				reqwin = BuildEasyRequest(&window, &es, 0, 0);
				D(bug("IPrefs: reqwin 0x%lx\n",
					(ULONG) reqwin));

				while (! (((srhret = SysReqHandler(reqwin, 0, FALSE)) >= 0) ||
					((winnum=WindowsLeftOnWB()) == 1 || autotries >= 5)) )
				{
					D(bug("IPrefs: sleep,retry %ld current winnum %ld\n",
					      (LONG) autotries,
					      (LONG) winnum));
					Delay(5);
					D(bug("IPrefs: wake up\n"));
				}
				FreeSysRequest(reqwin);
				D(bug("IPrefs: srhret %ld\n",
				      srhret));

				if (srhret == 0)
				{
					D(bug("IPrefs: cancel..leave retry\n"));
					break;
				}
				else
				{
					autotries++;
					D(bug("IPrefs: autotries %ld\n",
						(LONG) autotries));
				}
			}
			else if (winnum == 0)
			{
				if (!FindWBScreen()) break;
			}
		} while (!(closewbret=CloseWorkBench()));
	}

	D(bug("IPrefs: closewbret %ld\n",
		(LONG) closewbret));

	if (srhret != 0)
	{
		D(bug("IPrefs: reopen Workbench\n"));
		OpenWorkBench();
	}
}

#endif /* USE_DELAYEDREOPENWB */

/*********************************************************************************************/

AROS_UFH1(LONG, ScreenPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct ScreenModePrefs prefs,oldprefs;
	struct Screen *MyScreen;

	D(bug("IPrefs: ScreenPrefs\n"));

	ReadChunkBytes(iff, &prefs, sizeof(prefs));

	D(bug("IPrefs: DisplayID 0x%lx\n",
	      prefs.smp_DisplayID));

	D(bug("IPrefs: Width %ld Height %ld Depth %ld Control 0x%lx\n",
	      (LONG) prefs.smp_Width,
	      (LONG) prefs.smp_Height,
	      (LONG) prefs.smp_Depth,
	      (ULONG) prefs.smp_Control));

	MyScreen = FindWBScreen();

	SetIPrefs(&oldprefs.smp_DisplayID,sizeof (oldprefs) - 16, IP_OLDSCREENMODE);

	SetIPrefs(&prefs.smp_DisplayID, sizeof(prefs) - 16, IP_SCREENMODE);

	if (MyScreen)
	{
		D(bug("IPrefs: Workbench screen found\n"));

		if (NewScreenData(MyScreen, &prefs, &oldprefs))
		{
			D(bug("IPrefs: screen parameters are new\n"));
			D(bug("IPrefs: Attempt to reopen Workbench screen\n"));
			ReOpenWBScreen(MyScreen);
		}
		else
		{
			D(bug("IPrefs: screen parameters are old..don't change screen\n"));
		}
	}
	else
	{
		D(bug("IPrefs: No Workbench screen found\n"));
	}

	return 0;
	AROS_LIBFUNC_EXIT
}

/*********************************************************************************************/

#define PSD_MAXLEN_NAME         32
#define PSD_MAXLEN_TITLE       128
#define PSD_MAXLEN_FONT         48
#define PSD_MAXLEN_BACKGROUND  256
#define PSD_MAXLEN_SKIN         32
#define PSD_MAXLEN_MONITOR      32
#define PSD_NUMCOLS              8
#define PSD_MAXSYSPENS          20
#define PSD_NUMSYSPENS          12
#define PSD_MAXMUIPENS          10
#define PSD_NUMMUIPENS  MPEN_COUNT

#define PSD_TYPE_NORMAL          0
#define PSD_TYPE_AMBIENT         1

struct MUI_RGBcolor
{
	ULONG red;
	ULONG green;
	ULONG blue;
};

struct PubScreenDesc
{
	LONG  Version;

	char  Name[PSD_MAXLEN_NAME];
	char  Title[PSD_MAXLEN_TITLE];
	char  Font[PSD_MAXLEN_FONT];
	char  Background[PSD_MAXLEN_BACKGROUND];
	ULONG DisplayID;

	UWORD DisplayWidth;
	UWORD DisplayHeight;

	UBYTE DisplayDepth;
	UBYTE OverscanType;
	UBYTE AutoScroll;
	UBYTE NoDrag;
	UBYTE Exclusive;
	UBYTE Interleaved;
	UBYTE SysDefault;
	UBYTE Behind;
	UBYTE AutoClose;
	UBYTE CloseGadget;
	UBYTE DummyWasForeign;

	BYTE SystemPens[PSD_MAXSYSPENS];
	UBYTE psd_Reserved[1+7*4-PSD_MAXSYSPENS];

	struct MUI_RGBcolor Palette[PSD_NUMCOLS];
	struct MUI_RGBcolor rsvd[PSD_MAXSYSPENS-PSD_NUMCOLS];

	struct MUI_PenSpec rsvd2[PSD_MAXMUIPENS];

	LONG Changed;
	APTR UserData;

	char  Skin[PSD_MAXLEN_SKIN];
	ULONG Type;
	char  Monitor[PSD_MAXLEN_MONITOR];
};

AROS_UFH1(LONG, MUIScreenPrefs_Handler,
		  AROS_UFHA(struct IFFHandle *, iff, A2))
{
	AROS_LIBFUNC_INIT

	struct ScreenModePrefs prefs,oldprefs;
	struct PubScreenDesc pubscr = {0};
	struct Screen *MyScreen;

	char skinname[PSD_MAXLEN_SKIN] = {0};
	BOOL skinchanged = FALSE;

	D(bug("IPrefs: MUIScreenPrefs\n"));

	ReadChunkBytes(iff, &pubscr, sizeof(pubscr));

	if ((pubscr.Type == PSD_TYPE_AMBIENT) && (strcmp(pubscr.Name,"Ambient") == 0))
	{

		MyScreen = FindWBScreen();
		//setup prefs structure!
		D(bug("Translating MUI prefs to prefs format\n"));

		if (!MyScreen)
		{
			if ((pubscr.DisplayID == INVALID_ID || (!FindDisplayInfo(pubscr.DisplayID))))
			{
				pubscr.DisplayID = BestCModeIDTags(CYBRBIDTG_NominalWidth,pubscr.DisplayWidth,CYBRBIDTG_NominalHeight,pubscr.DisplayHeight,
				                                   CYBRBIDTG_Depth,pubscr.DisplayDepth,
				                                   (pubscr.Monitor[0]) ? CYBRBIDTG_MonitorName : TAG_IGNORE, (ULONG)pubscr.Monitor,
				                                   TAG_DONE);
			}
		} else {
			if ((pubscr.DisplayID == INVALID_ID || (!FindDisplayInfo(pubscr.DisplayID))))
			{
				return 0;
			}
		}

		prefs.smp_DisplayID = pubscr.DisplayID;
		prefs.smp_Width = pubscr.DisplayWidth;
		prefs.smp_Height = pubscr.DisplayHeight;
		prefs.smp_Depth = pubscr.DisplayDepth;
		prefs.smp_Control = pubscr.AutoScroll ? SMF_AUTOSCROLL : 0;
		
		D(bug("IPrefs: DisplayID 0x%lx\n",
		      prefs.smp_DisplayID));

		D(bug("IPrefs: Width %ld Height %ld Depth %ld Control 0x%lx\n",
		      (LONG) prefs.smp_Width,
		      (LONG) prefs.smp_Height,
		      (LONG) prefs.smp_Depth,
		      (ULONG) prefs.smp_Control));

		SetIPrefs(&oldprefs.smp_DisplayID, sizeof (prefs) -16, IP_OLDSCREENMODE);

		SetIPrefs(&prefs.smp_DisplayID, sizeof(prefs) - 16, IP_SCREENMODE);

		SetIPrefs(skinname, sizeof(skinname), IP_OLDSKINNAME);

		if (pubscr.Skin[0])
		{
			if (strcmp(skinname,pubscr.Skin) != 0)
			{
				SetIPrefs(pubscr.Skin,PSD_MAXLEN_SKIN,IP_SKINNAME);
				skinchanged = TRUE;
			}
		} else {
			//we might run into a situation in which skin name wasn't set

			if (strcmp(skinname,"Default") != 0)
			{
				SetIPrefs("Default",7,IP_SKINNAME);
				skinchanged = TRUE;
			} else {
				skinchanged = FALSE;
			}

			if (strcmp(skinname,"Ghost") != 0)
			{
				SetIPrefs("Ghost",7,IP_SKINNAME);
				skinchanged = TRUE;
			} else {
				skinchanged = FALSE;
			}
		}

		if (MyScreen)
		{
			D(bug("IPrefs: Workbench screen found\n"));

			if (skinchanged || NewScreenData(MyScreen, &prefs, &oldprefs))
			{
				D(bug("IPrefs: screen parameters are new\n"));
				D(bug("IPrefs: Attempt to reopen Workbench screen\n"));
				ReOpenWBScreen(MyScreen);
			}
			else
			{
				D(bug("IPrefs: screen parameters are old..don't change screen\n"));
			}
		}
		else
		{
			D(bug("IPrefs: No Workbench screen found\n"));
		}
	}

	return 0;
	AROS_LIBFUNC_EXIT
}

#define LINESIZE 2048

void LoadScreenPrefs(char *name)
{
	LONG rc = FALSE;
	BPTR fh = Open(name, MODE_OLDFILE);
	ULONG changed = 0;

	if (fh)
	{
		struct RDArgs *rda = AllocDosObject(DOS_RDARGS, NULL);
		if (rda)
		{
			UBYTE *line = AllocMem(LINESIZE, MEMF_ANY);
			if (line)
			{
				while (!rc && FGets(fh, line, LINESIZE - 1))
				{
					// args from MUI directly :))
					enum                 {     NAME    ,  TITLE    ,  FONT,    BACK,    SKIN,     MONITOR,  HOTKEY,     MW,    MH,    MD,    WIDTH,        HEIGHT,      DEPTH,       MODEID,       OVERSCAN,    C0,  C1,  C2,  C3,  C4,  C5,  C6,  C7,  S0,    S1,    S2,    S3,    S4,    S5,    S6,    S7,    S8,    S9,    S10,    S11,  P_AUTOSCROLL,P_INTERLEAVED,P_NODRAG,P_EXCLUSIVE,P_SYSDEFAULT,P_BEHIND,P_AUTOCLOSE,P_CLOSEGADGET,P_CHANGED,P_COMPOSITING,P_UNPARSEABLE_FLUFF,P_COUNT };
					const char template[] = "N=NAME/A/K,T=TITLE/A/K,F=FONT/K,B=BACK/K,S=SKIN/K,MM=MONITOR/K,HK=HOTKEY/K,MW/N/K,MH/N/K,MD/N/K,W=WIDTH/N/K,H=HEIGHT/N/K,D=DEPTH/N/K,ID=MODEID/N/K,OS=OVERSCAN/N/K,C0/K,C1/K,C2/K,C3/K,C4/K,C5/K,C6/K,C7/K,S0/N/K,S1/N/K,S2/N/K,S3/N/K,S4/N/K,S5/N/K,S6/N/K,S7/N/K,S8/N/K,S9/N/K,S10/N/K,S11/N/K,AUTOSCROLL/S,INTERLEAVED/S,NODRAG/S,EXCLUSIVE/S,SYSDEFAULT/S,BEHIND/S,AUTOCLOSE/S,CLOSEGADGET/S,CHG/N/K,COMPOSITING/K,/F";
					LONG *args[P_COUNT];
					APTR rdargs;
					int len = strlen(line);
					if (!len || line[len - 1] != '\n')
					{
						line[len++] = '\n';
					}

					if (line[0] != 'N' || line[1] != '=')
					{
						dprintf("continue cause of %s\n",line);
						continue;
					}

					rda->RDA_Source.CS_Buffer = line;
					rda->RDA_Source.CS_Length = len;
					rda->RDA_Source.CS_CurChr = 0;
					rda->RDA_Flags = RDAF_NOPROMPT;
					memset(&args, 0, sizeof(args));
					rdargs = ReadArgs(template, (LONG *) &args, rda);

					if (rdargs)
					{
						if (args[NAME] && !strcmp((char*)args[NAME], "Ambient"))
						{
							/* Got Ambient screen details, change the screen :) */
							ULONG tags[] =
							{
								IPA_Skin,(ULONG)args[SKIN],
								IPA_ModeMonitor,(ULONG)args[MONITOR],
								#define LONGTAG(_pname,_tname) \
									args[_pname] ? _tname : TAG_IGNORE,args[_pname] ? (ULONG)*args[_pname] : 0,
								LONGTAG(MW,IPA_ModeWidth)
								LONGTAG(MH,IPA_ModeHeight)
								LONGTAG(MD,IPA_ModeDepth)
								LONGTAG(WIDTH,IPA_DisplayWidth)
								LONGTAG(HEIGHT,IPA_DisplayHeight)
								LONGTAG(DEPTH,IPA_DisplayDepth)
								LONGTAG(MODEID,IPA_ModeID)
								LONGTAG(OVERSCAN,IPA_OverscanType)
								IPA_AutoScroll,(ULONG)args[P_AUTOSCROLL],
								IPA_Compositing,args[P_COMPOSITING] ? (Stricmp((char*)args[P_COMPOSITING],"yes") == 0 ? TRUE : FALSE) : TRUE,
								TAG_DONE,0
							};

							changed = SetIPrefs(&tags, 0, IP_NEWSCREENTAGS);

							rc = TRUE;
						}

						FreeArgs(rdargs);
					}
				}

				FreeMem(line, LINESIZE);
			}

			FreeDosObject(DOS_RDARGS, rda);
		}

		Close(fh);
	}

	if (changed)
	{
		struct Screen *MyScreen;
		MyScreen = FindWBScreen();
		ReOpenWBScreen(MyScreen);
	}
	return;
}

